Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPEnvMap/GTPEnvMap.hlsl
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPEnvMap/GTPEnvMap.hlsl	(revision 2471)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPEnvMap/GTPEnvMap.hlsl	(revision 2550)
@@ -63,4 +63,19 @@
 }
 
+float4 EnvMap_Refract_Default_PS
+					(Shaded_OUT IN,
+					uniform samplerCUBE CubeMap : register(s0),
+					uniform float3 cameraPos,
+					uniform float sRefraction,
+					uniform float transparency ) : COLOR0
+{
+	float3 N = normalize(IN.wNormal.xyz);
+	float3 V = normalize(IN.wPos.xyz - cameraPos);
+	float3 R = reflect( V, N);	
+	float3 R2 = refract( V, N, sRefraction);	
+	
+	return 0.5;//(1.0 - transparency) * readCubeMap(CubeMap, R ) + transparency * readCubeMap(CubeMap, R2);
+}
+
 float4  EnvMap_Localized_Reflection_PS( Shaded_OUT IN,
 										uniform samplerCUBE CubeMap : register(s0),
@@ -88,5 +103,5 @@
 										uniform float3 cameraPos,
 										uniform float3 lastCenter,		
-										uniform float sFresnel,
+										uniform float4 sFresnel,
 										uniform float sRefraction ) :COLOR0
 {
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPEnvMap/GTPEnvMap.program
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPEnvMap/GTPEnvMap.program	(revision 2040)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPEnvMap/GTPEnvMap.program	(revision 2550)
@@ -3,4 +3,11 @@
 	source GTPEnvMap.hlsl
 	entry_point EnvMap_Default_PS
+	target ps_2_0
+}
+
+fragment_program GTP/EnvMap/Default_Refract_PS hlsl
+{
+	source GTPEnvMap.hlsl
+	entry_point EnvMap_Refract_Default_PS
 	target ps_2_0
 }
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic_PS.hlsl
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic_PS.hlsl	(revision 2312)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic_PS.hlsl	(revision 2550)
@@ -41,4 +41,5 @@
 				uniform float farplane) : COLOR
 {
+//return float4(0.5,0,0,0);
  return float4(-IN.CPos.z, -IN.CPos.z / farplane, 0, -IN.CPos.z);	
 }
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPShadowMap_PS.hlsl
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPShadowMap_PS.hlsl	(revision 2507)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPShadowMap_PS.hlsl	(revision 2550)
@@ -40,4 +40,22 @@
   }		
   return light;	
+}
+
+float4 shadowMapCameraDepth(LightCPos_OUT IN,
+                      uniform sampler2D shadowMap) : COLOR
+{
+  float4 light = shadowColor;	  
+	
+ 
+	float4 pos = (IN.LightVPos / IN.LightVPos.w);
+		
+	pos.xy = (pos.xy + 1.0) / 2.0;
+	pos.y = 1.0 - pos.y;
+	float storedDepth = tex2D(shadowMap, pos.xy).r;
+	//light = (pos.z - storedDepth.r)*100.0;
+	float depth = -IN.LightCPos.z;
+	light = max(storedDepth + DEPTH_BIAS > depth, shadowColor2);			
+	return storedDepth;
+	return light;	
 }
 
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic.program
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic.program	(revision 2404)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic.program	(revision 2550)
@@ -172,4 +172,11 @@
    source GTPShadowMap_PS.hlsl
    entry_point shadowMapDepth
+   target ps_2_0
+}
+
+fragment_program GTP/Basic/SM/CameraDepth_PS hlsl
+{
+   source GTPShadowMap_PS.hlsl
+   entry_point shadowMapCameraDepth
    target ps_2_0
 }
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic.material
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic.material	(revision 2489)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic.material	(revision 2550)
@@ -73,5 +73,5 @@
   pass mainpass
   {
-   cull_hardware clockwise
+   cull_hardware none
    vertex_program_ref GTP/Basic/CPos_VS
    {  
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/Towers/towers.material
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/Towers/towers.material	(revision 2507)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/Towers/towers.material	(revision 2550)
@@ -37,7 +37,7 @@
   			fragment_program_ref GTP/Demo/ParallaxMapped_PS
   			{
-  			 param_named HEIGHT_SCALE float 0.16
+  			 param_named HEIGHT_SCALE float 0.20
   			 param_named HEIGHT_BIAS float -0.04  			
-  			 param_named textureRepeat float 6
+  			 param_named textureRepeat float 10
    			}
 			texture_unit color
@@ -173,12 +173,14 @@
 				{
 					max_light_count 1
-					vertex_program_name GTP/Basic/LightVPos_VS
-					fragment_program_name GTP/Basic/SM/Depth_VSM_PS
+					vertex_program_name GTP/Basic/LightCPos_VS
+					fragment_program_name GTP/Basic/SM/CameraDepth_PS
 					set_light_viewproj true
-					set_light_view false
+					set_light_view true
 					set_light_farplane false
 					world_view_proj_param_name WorldViewProj
 					world_param_name World
 					light_viewproj_param_name LightViewProj			
+					light_view_param_name LightView	
+					pass_blending one zero
 				}	
 
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/Towers/parallax.hlsl
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/Towers/parallax.hlsl	(revision 2441)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/Towers/parallax.hlsl	(revision 2550)
@@ -14,12 +14,12 @@
 	float det = B2 * T2 - BT * BT;
 
-	return float3x3( (B2 * Tangent - BT * Binormal)/det, 
-	                 (T2 * Binormal - BT * Tangent)/det, 
-	                 Normal/N2 );
+	//return float3x3( (B2 * Tangent - BT * Binormal)/det, 
+	//                 (T2 * Binormal - BT * Tangent)/det, 
+	//                 Normal/N2 );
 		                               		
 	// simplified solution
 	//return float3x3(Tangent/T2, Binormal/B2, Normal/N2); 
 	// more simplified solution
-	//return float3x3(Tangent, Binormal, Normal);
+	return float3x3(Tangent, Binormal, Normal);
 }
 
@@ -89,8 +89,9 @@
      
     // performing parallax mapping
-    float2 ParallaxTex = PARALLAX_MAPPING_ITER(BumpMapSampler, IN.TexCoord, tView);
+    float2 ParallaxTex = PARALLAX_MAPPING_OFFSET_LIMIT(BumpMapSampler, IN.TexCoord, tView);
 	DISCARD_BY_TEX(ParallaxTex);
 	
     // get model space normal vector
+    //ParallaxTex = IN.TexCoord;
     float3 tNormal = tex2D(BumpMapSampler, ParallaxTex).rgb;
 	// Normal vector should be transformed with the inverse transpose of TangentToModel
@@ -98,5 +99,7 @@
     float3 mNormal = normalize( mul( tNormal, ModelToTangent ) ); 
 	//mNormal = normalize(IN.wNormal);
+
     // illumination calculation
+
     return Illumination(mLight, mNormal, mView, ParallaxTex, IN.TexCoord2);
 }
Index: GTP/trunk/App/Demos/Illum/Ogre/src/ShadowDemo/include/ShadowDemo.h
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/ShadowDemo/include/ShadowDemo.h	(revision 2509)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/ShadowDemo/include/ShadowDemo.h	(revision 2550)
@@ -187,5 +187,6 @@
 		OgreIlluminationManager::getSingleton().setMainViewport(mWindow->getViewport(0));
 		OgreIlluminationManager::getSingleton().setShadowMapSize(700);
-		OgreIlluminationManager::getSingleton().setShadowMapMaterialName("GTP/Basic/Depth");
+		//OgreIlluminationManager::getSingleton().setShadowMapMaterialName("GTP/Basic/Depth");
+		OgreIlluminationManager::getSingleton().setShadowMapMaterialName("GTP/Basic/CameraDepth");
 		OgreIlluminationManager::getSingleton().setFocusingSM(true);
 	   OgreIlluminationManager::getSingleton().setBlurShadowMap(true);
Index: GTP/trunk/App/Demos/Illum/Ogre/src/SpaceStation/include/SpaceStation.h
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/SpaceStation/include/SpaceStation.h	(revision 2525)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/SpaceStation/include/SpaceStation.h	(revision 2550)
@@ -30,4 +30,5 @@
 bool highQuality = true;
 bool chc = false;
+bool constantTimeStep = false;
 
 Scene* NXScene = 0;
@@ -464,14 +465,17 @@
 		CompositorManager::getSingleton().setCompositorEnabled(mWindow->getViewport(0),
 														"GTP/SpaceStation/PostProc/DoF", true);*/
-
-		CompositorManager::getSingleton().addCompositor(mWindow->getViewport(0),
-														"GTP/Station/PostProc/Glow");
-		CompositorManager::getSingleton().setCompositorEnabled(mWindow->getViewport(0),
+		if(highQuality)
+		{
+			CompositorManager::getSingleton().addCompositor(mWindow->getViewport(0),
+															"GTP/Station/PostProc/Glow");
+			CompositorManager::getSingleton().setCompositorEnabled(mWindow->getViewport(0),
 														"GTP/Station/PostProc/Glow", true);
-		
-		CompositorManager::getSingleton().addCompositor(mWindow->getViewport(0),
-														"GTP/PostProc/ToneMap");
-		CompositorManager::getSingleton().setCompositorEnabled(mWindow->getViewport(0),
-														"GTP/PostProc/ToneMap", true);	
+		}
+		
+			CompositorManager::getSingleton().addCompositor(mWindow->getViewport(0),
+															"GTP/PostProc/ToneMap");
+			CompositorManager::getSingleton().setCompositorEnabled(mWindow->getViewport(0),
+															"GTP/PostProc/ToneMap", true);	
+		
 		/*		
 		CompositorManager::getSingleton().addCompositor(mWindow->getViewport(0),
@@ -500,5 +504,6 @@
 		//Overlay* mainOverlay = OverlayManager::getSingleton().getByName("MORIA/MainOverlay");
 		//mainOverlay->show();
-
+		
+		//if(highQuality)
 		createPostproc();
 
@@ -538,4 +543,5 @@
 		s.setWorld(NXWorld);
 		s.parseScript(inputStream, ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME);
+		if(highQuality)
 		s.parseEntryPoints("StationPrmEntryPoints.text");
 	
@@ -673,7 +679,25 @@
 	void createFrameListener(void)
     {
-		// This is where we instantiate our own frame listener
+		if(constantTimeStep)
+		{
+			// This is where we instantiate our own frame listener
+			class constantTimeStep : public FrameListener
+			{
+			public:
+				bool frameStarted(const FrameEvent &evt)
+				{
+					FrameEvent* event = (FrameEvent*) &evt;
+					event->timeSinceLastFrame = 1000 / 20;
+					return true;
+				}
+			};
+			constantTimeStep* ct = new constantTimeStep;
+			ct->setPriority(1);
+			mRoot->addFrameListener(ct);
+		}
+
 		mFrameListener= new SpaceStationFrameListener(mWindow,
 			mCamera, roomLightNode, roomLight, hallLight, pSysNode	);
+
         mFrameListener->setPriority(10);	
 		mRoot->addFrameListener(mFrameListener);
Index: GTP/trunk/App/Demos/Illum/Ogre/src/SpaceStation/src/SpaceStation.cpp
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/SpaceStation/src/SpaceStation.cpp	(revision 2525)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/SpaceStation/src/SpaceStation.cpp	(revision 2550)
@@ -43,8 +43,14 @@
 #if OGRE_PLATFORM == OGRE_PLATFORM_WIN32
 	String args = strCmdLine;
-	if(StringUtil::match(args, "low"))
-		highQuality = false;
-	if(StringUtil::match(args, "chc"))
-		chc = true;
+	std::vector<String> arguments = StringUtil::split(args);
+	for(std::vector<String>::iterator it = arguments.begin(); it != arguments.end(); it++)
+	{
+		if(StringUtil::match(*it, "low"))
+			highQuality = false;
+		if(StringUtil::match(*it, "chc"))
+			chc = true;
+		if(StringUtil::match(*it, "cts"))
+			constantTimeStep = true;
+	}
 #endif
     // Create application object
Index: GTP/trunk/App/Demos/Illum/Ogre/bin/Release/ogre.cfg
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/bin/Release/ogre.cfg	(revision 2519)
+++ GTP/trunk/App/Demos/Illum/Ogre/bin/Release/ogre.cfg	(revision 2550)
@@ -2,9 +2,9 @@
 
 [Direct3D9 Rendering Subsystem]
-Allow NVPerfHUD=Yes
+Allow NVPerfHUD=No
 Anti aliasing=None
-Floating-point mode=Fastest
+Floating-point mode=Consistent
 Full Screen=No
 Rendering Device=NVIDIA GeForce 6800 GT
 VSync=No
-Video Mode=640 x 480 @ 32-bit colour
+Video Mode=800 x 600 @ 16-bit colour
Index: GTP/trunk/App/Demos/Illum/Ogre/bin/Debug/ogre.cfg
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/bin/Debug/ogre.cfg	(revision 2315)
+++ GTP/trunk/App/Demos/Illum/Ogre/bin/Debug/ogre.cfg	(revision 2550)
@@ -8,3 +8,3 @@
 Rendering Device=NVIDIA GeForce 6800 GT
 VSync=No
-Video Mode=800 x 600 @ 32-bit colour
+Video Mode=640 x 480 @ 32-bit colour
